\documentclass[10pt,a4paper]{article}
\usepackage[left=3cm, right=3cm, top=2cm, bottom=2cm]{geometry}
\usepackage{url}
\usepackage{parskip}
\usepackage{graphicx}
\usepackage[numbers]{natbib}
\usepackage[toc,page]{appendix}
\usepackage{caption}
\usepackage{subcaption}
\usepackage{verbatim}
\usepackage{standalone}
\usepackage[hidelinks]{hyperref}
\usepackage{amssymb}
\usepackage{amsmath}
\usepackage{float}
\usepackage{wrapfig}
\usepackage{tcolorbox}
\usepackage{lipsum}
\usepackage{hyperref}
\usepackage[section]{placeins}
\usepackage{authblk}
\usepackage{hyperref}
\usepackage{booktabs}
%
\newcommand*{\email}[1]{%
    \normalsize\href{mailto:#1}{#1}\par
}
\renewcommand{\arraystretch}{1.3}
\newenvironment{WrapText}[1][r]
  {\wrapfigure{#1}{0.5\textwidth}\tcolorbox}
  {\endtcolorbox\endwrapfigure}
\def\realnumbers{\mathbb{R}}
\DeclareMathOperator*{\argmin}{arg\,min}
\DeclareMathOperator*{\argmax}{arg\,min}
\newtheorem{theorem}{Theorem}{}
\newtheorem{corollary}{Corollary}{}
\newtheorem{remark}{Remark}{}

\bibliographystyle{IEEEtran}

\begin{document}

\title{Evaluating a Relaxation Approach to Optimal Scheduling in Smart Microgrids with Almost Convex Device Flexibility}
\author{Samuel Pinkus}
\affil{Faculty of Science, Engineering and Technology, Swinburne University of Technology, Melbourne, Australia\\ \email{spinkus@swin.edu.au}}

\begin{abstract}
An important task in effective operation of modern microgrids is optimal the scheduling of heterogeneous controllable devices over a short future time horizon, typically a day-ahead. In order to optimally schedule microgrid devices a well-defined model of device costs and constraints, herein just called device ``flexibility'' is first required. Convex modelling is often used to capture device flexibility because it provides an appealing trade off between representability, generality, and solvability. A convex model has the advantage of being exactly solvable with well known fast convex optimisation methods, and can also often be decomposed and solved using distributed approaches. However, while many devices can be modelled as convex to a level of precision sufficient for day-ahead scheduling, some very common and simple types of constraints that are desirable to capture are just not very close to convex. Two such common constraints are discrete run-level constraints (such as off, low, medium, high levels) and sliding-window constraints (a device starts and must run for a set period of time without interuption). The modeler faces a choice of ignoring such constraints, relaxing them by transforming into convex ones (technically ignoring is an extreme type of relaxation), or abandoning the convex model and the advantages that come with it for a more accurate but harder to solve and work with mixed integer model. This work explores the feasibility of relaxation and refitting approach to dealing with the two aforementioned non-convex device scheduling constraints (run-levels and sliding-window). The non-convex constraints are relaxed resulting in a convex model which is then solved. Then the non-convex constraints are reintroduced, and the solution refitted resulting in a feasible solution according to the original non-convex constraints. The approach presented is almost trivial and far from revolutionary. Never the less, we wanted to evaluate approach and go to answering ``how realistic is it?'' for the types of microgrid modelling scenarios we are encountering. We can't provide general answers to that question. Mileage will likely vary widely depending on the model, but the results show at least for these simple types of non convex constraints and the real world model considered the methods is effective and errors relatively low.

\end{abstract}

\maketitle

\section{Background and Introduction}\label{sec-introduction}
Conventional top down, centralised control architectures of the grid will not scale to the future distributed energy system. A physically distributed energy supply requires decentralised control. The microgrid concept is seen as a key enabler of effective integration of future high penetrations of distributed generation \cite{Hatziargyriou2014FrontMatter, Lasseter2004}. A microgrid is a small, autonomously controlled, generally low voltage electricity distribution network. Conceptually, microgrids are viewed as integration platforms for heterogeneous DER (Distributed Energy Resources) and application loads \cite{Schwaegerl2013}. In envisioned future scenarios, microgrids will intelligently coordinate supply and demand of electricity within their own domains autonomously from a wider electricity system \cite{Coelho2017}. These autonomous microgrids may be islanded, or connected to neighbouring autonomous systems for the bidirectional exchange of energy where it is viable and beneficial to both sides \cite{Guerrero2013Hierarchical}.

Hierarchical control architectures modelled after large scale grids are most commonly considered for microgrids \cite{Guerrero2013Hierarchical, Claessen2014}. At the highest operational level, optimal control of microgrids involves, or is envisioned to involve, scheduling the operation (i.e. the rate of production or consumption of electrical energy) of heterogeneous controllable generation, storage and loads over a short future time horizon. For practical reasons, a finite time horizon of a day ahead is commonly assumed, and time is usually discretised into intervals of 5 to 60 minutes \cite{Nunna2013Multiagent}. Since day-ahead schedules are based on supply and demand forecasts with a degree of uncertainty, lower layers of control handle making adjustments to schedules closer to real-time. Still lower layers handle voltage and frequency stability reacting in millisecond time frames \cite{Guerrero2013Hierarchical}. While all the layers of the microgrid technology stack are currently active areas of research, in this work we are concerned with the discrete time finite horizon optimal scheduling problem, occurring at the highest layers.

In order to optimally schedule heterogeneous microgrid devices, a well-defined model of device flexibility is required. The model serves, or will serve, as the basis for the control interfaces of devices in real life microgrids, but can also used in preliminary simulation in order to answer broad economic questions about the operation of microgrids, under various cost assumptions, configurations or control methodologies.

Convex modelling has been widely used to capture microgrid and demand side device scheduling flexibility in the mathematical form \cite{Zhang2013Robust, Li2011, Mohsenian2010Autonomous, Papavasiliou2010}. In a convex model, electricity is treated as an arbitrarily divisible scalar valued ``flow'' commodity. Device consumption and production constraints form a convex subset of a real valued vector space, and the various device operational costs form a convex function over that space. It is often the case that cost functions are naturally convex (noting \textit{dis}-utility functions, which are inverted utility functions, are treated as just another kind of cost function in this work).

Convex modelling provides a good trade off between representability, generality, and solvability. When the model is convex, strong results with respect to the existence, uniqueness and stability of a globally optimal solution apply and many well known algorithms are available for finding the optimal solution \cite{Boyd2004Convex}. More over, the central optimisation problem can often be decomposed into an equivalent distributed algorithm, which is an important consideration in a distributed and multi-tenant microgrid setting \cite{Palomar2006}. Sensitivity analysis (how the value of the objective function changes with small changes in some parameter such as the capacity of a battery) is potentially easier to perform because the Lagrangian multipliers are often available as a result of convex optimisation and have a specific interpretation in sensitivity analysis \cite{Boyd2004Convex}.

While many devices can be modelled to the required precision while maintaining convexity, strictly convex modelling is often passed over for harder to solve, harder to decompose mixed integer models, because some common simple types of constraint are not closely representable as convex. Two commonly encountered examples are devices with a small number of discrete run levels and uninterruptible but shiftable devices \cite{Molderink2010, Jiang2015Smart, Claessen2014, Ramchurn2011, Corchero2014Optimal, Zhang2011Optimal}. Many common electrical appliances only have a fixed number of operational consumption or production levels. When a large number of uniformly distributed run levels are available this is not really an issue, as the error in a continuous (convex) approximation diminishes with the number of run levels. But many devices have a small number of possibly non uniformly distributed run levels. For example a pool pump might only have on and off states. Another example is the Australian standard AS4755.3.1 which mandates that a fully compliant air conditioner must support 0\%, 50\% ,75\%, 100\% operating states, where the percentages refer to energy consumption in that state \cite{AS4755.3.1}. An uninterruptible but shiftable device is one in which the device's start time is flexible but the device cannot be interrupted once it starts. In the scheduling problem we consider, and as most commonly posed, start time is effectively a discrete variable, which makes this constraint non-convex. A device may be semi-uninterruptible to degrees, meaning it has some flexibility within a given fixed run time window. For example a household dishwasher or clothes washer could stop running, or possibly running at a lower rate for an hour or two, but interruptions in the order of a few hours would most likely be considered infeasible.

Given the level of precision required in a day-ahead scheduling solution, it would be preferable not to abandon the benefits of a convexity, especially for the sake of structurally simple non-convex constraints such as those discussed above. In this work, we evaluate a simple relaxation and refitting approach to maintaining convexity of the central microgrid scheduling problem, focusing on discrete run level and uninterruptible shiftable constraints for brevity. The general approach can potentially be applied to other types of constraints as they are encountered.

Section \ref{sec-model} formally defines the abstract model of a microgrid we consider. To enable us to succinctly define a concrete microgrid model, section \ref{sec-flexibility-model} develops an device flexibility constraint language from which device flexibility models are composed. Section \ref{sec-rnr} defines how non convex constraints are relaxed and reintroduced after optimization. In section \ref{sec-experiments} we define a concrete model of a case study microgrid involving a significant number of devices with non-convex constraints. The case study scenario is hypothetical but based on future projections for a real-life rural microgrid setting \cite{Morsali2018Demand}. Section \ref{sec-results} presents the results of applying the relaxation approach in this microgrid case study. Conclusions are given in section \ref{sec-conclusion}.

\section{Microgrid Model}\label{sec-model}

\subsection{Microgrid Structure and Scheduling Problem}\label{sec-model-mg}
We assume the following general and abstract model of a microgrid suitable for formulation of the centralised day-ahead scheduling problem, based on previous works \cite{Li2011, Zhang2013Robust, Lasseter2004} and standard (but simplified) power flow analysis \cite{Bergen2000}.

A microgrid is considered a lossless undirected active power flow network. We assume the microgrid network is \textit{radial}, which means the network has a \textit{tree} structure. Figure \ref{fig-mg-network} shows a depiction of a such a tree structured microgrid.  In general such a tree structured network can be viewed as arbitrarily deep hierarchy of sub-networks within sub-networks. However in practice the depth is typically limited to 1 or 2 levels.

The edges of the tree are electrical lines. We assume line capacities are unconstrained. The nodes of the tree can be partitioned into internal nodes and leaf nodes. Internal nodes represent buses. These are generally associated with some co-located and co-managed grouping of devices such as a tenant site (house, business, etc.), or some cluster of DERs. As in any lossless flow network, the sum of the flows through any internal node must sum to zero.

Leaf nodes are arbitrary sinks and sources of electrical power such as DER (solar arrays, micro turbines, electrical storage devices, etc.) or application loads (electric vehicles (EVs), washing machines, electric pumps, etc.). They may also represent connections to external autonomous electrical networks such as the macrogrid or neighbouring microgrids. We call all leaf nodes ``devices'' herein.

Let $T = \{1..n\}$ be the time slots in the day-ahead. Let $G(V, E)$ denote the microgrid network, where $V$ is set of nodes in the network and $E$ is the set of all edges connecting the nodes. $D \subset V$ is the set of devices (leaf nodes) with $|D| = m$. $B \subset V$ is the set of buses (internal tree nodes. These may also be viewed as sub-networks). We use the notation $N(v)$ to denote the nodes adjacent to any node $v$, and $Q_{\{u,v\}}$ to denote the power flow vector along edge $\{u,v\}$.

For all $d \in D$, let $Q_d \in \mathbb{R}^n$ denote the device's power flow vector over the day-ahead. We assume device in-flows are positive and out-flows are negative. Each device has a cost function over $Q_d$, $C_d(Q_d):\mathbb{R}^n \rightarrow \mathbb{R}$ that represents the cost of the given node's flow vector. Each device is constrained to some feasible space of power flows over time, $X_d \subseteq \mathbb{R}^n$. We assume there is no inherent cost associated with flow over bus nodes, and bus nodes are only possibly constrained by a simple carrying capacity constraint. Let $C_b$ be the capacity of bus $b$.

Note, given the tree structure of network a unique solution is given by specifying the flows at the device nodes, and may be specified by the matrix $Q \in \mathbb{R}^{m,n}$. The central optimisation objective is to find a feasible $Q$ that minimizes total costs:

\begin{subequations}
\begin{align}
  \min {} & \sum_d^D C_d(Q_d) \label{eq-central-objective}\\
  \text{s.t.} & \sum_d^D Q_{d,t} = 0 & \forall_{t \in T} \label{eq-mg-balance}\\
  & Q_d \in X_d & \forall_{d \in D}\\
  & \sum_{v}^{N(v)} |Q_{\{b,v\}}| \le 2 C_b & \forall_{b \in B}\label{eq-mg-bus}
\end{align}
\end{subequations}

where (\ref{eq-mg-balance}) is the balancing equation (flow-in = flow-out), and (\ref{eq-mg-bus}) are the bus capacity constraints, which form convex constraints over $Q$ \cite{Boyd2004Convex}.

Assuming we can collect all the relevant costs and constraints of the microgrid network, we can solve for the optimal flow of the entire network centrally. If the constraints and costs of all the devices are convex the central problem is convex and can be solved with well known convex optimisation techniques. Naturally, all of the nuance is in the constraints and costs of the devices. Whether the central problem is convex falls on whether each devices' scheduling flexibility can be reasonably accurately captured with convex costs and constraints.

Note that rather than collecting all relevant details and solving the scheduling problem centrally, a more practical approach may be to decompose the central convex problem and solve it in a decentralised fashion with a level of centralised coordination. This has a number of advantages, including reducing coupling, preserving privacy, avoiding a central computational bottle-neck, and potentially being robust in a non cooperative environment \cite{Palomar2006, Papavasiliou2010}. While the \textit{availability} of an exact decomposition is a strong motivation for maintaining convexity in device flexibility modelling, it is not our intent to explore decomposition in this work, but rather, the convex device flexibility modelling itself.

\begin{figure}[!h]
  \centering{\includegraphics[width=0.44\textwidth]{./img/tree-of-smart-homes.eps}}
  \caption{Abstract depiction of the electro-physical structure of a two level radial (tree structured) microgrid. Leaf nodes are DER, appliances, or connections to external autonomous systems. Internal nodes are power carrying buses of the microgrid. The edges represent electrical power flows. \label{fig-mg-network}}
\end{figure}

\section{Device Flexibility Modelling}\label{sec-flexibility-model}
A device's scheduling flexibility is defined by its feasible space, $X_d$, and cost function, $C_d$, over $X_d$. The constraints can be defined independently of costs. Section \ref{sec-device-constraints} defines a set of device modelling constraints from which $X_d$ is composed, without regards to particular cost functions that might be used with them. Cost functions naturally tend to depend on the constraint parameters since the constraints define the domain over which the cost functions are meaningful. Having defined a set of constraints, section \ref{sec-cost-functions} defines the handful of cost functions used in this work. Note that cost functions tend to be highly context and device specific and we do not attempt to define some wholistic set of cost functions that can be used in all cases, but merely the few used in this work, although they are fairly generic. Also note, where it is more intuitive, we will define device flexibility in terms of utility functions with the understanding that the corresponding cost function is merely the negation of the utility function.

\subsection{Device Constraints}\label{sec-device-constraints}
The feasible space for some device, $X_d$, is defined as the intersection of the feasible spaces of one or more of the constraints defined in the following sub sections. I.e. each device has a possibly empty set of constraints, $\mathcal{X}_d$, such that:

\begin{align}
  X_d & = \bigcap_{C \in \mathcal{X}_d} \{y \in \mathbb{R}^n\ |\ y\ \text{satisfies}\ C\}
\end{align}

Any given device may be constrained by a combination of any of the constraints listed in the following sub sections. While the presence of a given type of constraint on a device may imply that the device is of some semantic ``type'', we avoid defining a rigid partition of devices into types, since in general the same constraints may reused across many semantic types, and a given device may be of greater than one semantic type. Instead, we just define the constraints and use them in an compositional manner to model a given device as required (see section \ref{sec-experiments} for a concrete example of how the constraints are used for modelling actual devices).

The following constraints are derived from previous works \cite{Li2011, Ramchurn2011, Papavasiliou2010, Zhang2013Robust}.

\subsubsection{Interval Bounds Device Constraint (ibound)}
An interval bound (\textit{ibound} for short) constraint is merely a min and max bounding box on a given device's flow vector, $Q_d$. I.e.:

\begin{align}
  Q_{d}^{min} \le Q_d \le Q_{d}^{max}
\end{align}

where $Q_d^{min}$ and $Q_d^{max}$ are real valued vectors of length $n$. Typically all devices have an interval bound defined. For times when a device cannot or is not permitted to run $Q_{d,t}^{min} = Q_{d,t}^{max} = 0$. If for some reason a lower or upper bound is not applicable, it can be set to a appropriately small or large value for the given times. The nominal use of an interval bound is to capture the maximum power rating of an electrical device such as a battery max power rating. It is also used to model unscheduled devices. For any unscheduled devices it is assumed we can determine an expected power flow vector over the scheduling horizon, $Q_{d}^{exp}$. Such unscheduled devices are then modelled with a single interval bound constraint such that $Q_{d}^{min} = Q_{d}^{max} = Q_{d}^{exp}$.

\subsubsection{Cumulative Bounds Device Constraint (cbound)}
A cumulative bound (\textit{cbound} for short) gives the min/max cumulative flow constraints over some arbitrary subset times in the scheduling horizon (typically all times). A cumulative bound is a bounding lower and upper hyperplane over a device's flow vector:

\begin{align}
  E_d^{min} \le \sum_t^\mathcal{T} Q_{d,t} \le E_d^{max}, \mathcal{T} \subseteq T
\end{align}

A cumulative bound is used to model shiftability in demand or supply. For example the energy requirements to pump 100 litres of water into a reservoir are fixed, but the pumping may be able to be scheduled at anytime of day.

\subsubsection{Accumulative Bounds Device Constraint (abound)}
Simple storage and thermal devices are often modelled with a bound on the discrete integral of the power flow vector over time, since this is related to the amount of energy accumulated or dissipated from some energy storing entity like a battery or a thermal mass. In many such devices, input/output efficiency and self discharge (or more generally decay of energy state over time) are significant factors that need to be captured in the device modelling. An accumulative discrete interval bound (\textit{abound} for short) is described by the following real valued scalars:

\begin{itemize}
  \item current energy state, $S_{d,t}, \forall_t \in T$;
  \item initial energy state, $S_{d,0}$;
  \item min/max energy states $S_d^{min}$, $S_d^{max}$;
  \item minimum required energy state at the end of the scheduling horizon, $S_d^{end}$;
  \item efficiency factor, $f_d \in (0,1]$;
  \item discharge or decay rate factor, $l_d$;
  \item a scaling factor to convert to input/output energy units to internal energy state units, $k_d$.
\end{itemize}

Unlike a cumulative bound, the \textit{accumulative} bound must be defined over a contiguous sequence of time intervals, $\mathcal{T}  \subseteq T$. The constraint is implicitly defined by the following relationships between the above parameters and a given device's power flow vector:

\begin{subequations}
\begin{align}
  S_{d,t} & = l_d S_{t-1} + k_d f_d^{sign(Q_{d,t})}Q_{d,t} & \forall_t \in \{1..n\} \label{eq-di}\\
  S_d^{min} & \le S_{d,t} \le S_{d}^{max}\ & \forall_t \in \{0..n\}\\
  S_d^{min} & \le S_d^{end} \le S_{d,n} \le S_{d}^{max}
\end{align}
\end{subequations}

We assume the energy losses due to the efficiency factor $f_d$ occur in equal parts on input and output of a device (the $sign(Q_{d,t})$ exponent in (\ref{eq-di}) ensures this). If a device is only capable of consuming or producing power, this is captured by adding an appropriate interval bound to the device's set of constraints.

% Note with an efficiency factor less than 1.0, and when $Q_d$ is able to range over positive and negative values, technically the constraint space is non convex, due to possible changes in efficiency factor over the range. The consequence of this is there is a possibility a convex optimisation method such as a descent method converges to a local optimal. However, the scale of the effect on results, and the probability of this actually has any effect increases with decreasing efficiency factor. If the efficiency factor is kept reasonably high, say above 0.9 or so, the effect of this on results using convex optimisation, if any, should be negligible.

\subsubsection{Accumulative Bounds Device Constraint for Thermal Devices}
The energy state constraint on a thermal device, such as thermal energy storage device or some device responsible for maintaining the temperature of some thermal mass such as a refrigerator, is captured with the discrete integral constraint above. However, for thermal devices it is more convenient to specify energy state parameters in terms of temperature of some (presumed) fixed mass storing the thermal energy. Within certain bounds, temperature of a fixed mass will vary in proportion to the energy transfer into it. If the energy states of the discrete integral are in units of temperature, then a unit conversion factor, $k_d$ is required. $k_d$ is expected to be derived from the heat capacity of a given thermal mass associated with a device (potentially automatically derived from observational data).

In regards to thermal accumulative devices, ambient temperature often changes over the course of the day, and this can be a significant factor that should be captured in the modelling. However in this work we make do without it, assuming ambient temperature has a negligible effect. The above accumulative constraint can easily be extended to support an ambient temperature parameter (see \cite{Li2011, Ramchurn2011, Papavasiliou2010}).

Note that costs associated with accumulative devices, especially thermal accumulative devices, are often defined in terms of the energy state at any given time $S_{d,t}$, which is a function of the power input $Q_{d}$ vector. For clarity, when defining cost functions associated with thermal accumulative device constraints (as in \ref{sec-cost-functions} below), we assume access to the derived variable $S_{d}$ and define costs in terms of this derived variable rather than $Q_d$ directly.

\subsubsection{Run Levels Device Constraint (levels)}
The run levels constraint (\textit{levels} for short) specifies a finite list of discrete power consumption and/or production rates supported by a given device, $RL_d$:

\begin{align}
  Q_{d,t} \in RL_{d}, \forall t
\end{align}

As an example, for the case of an aforementioned AS4755.3.1 compliant air-conditioner with a maximum power rating of 10kW, $RL_d = \{0,5,7.5,10\}$, presuming power is measured in units of kilowatts.

\subsubsection{Operating Window Device Constraint (window)}
The following operating window constraint (\textit{window} for short) can be used to capture an uninterruptible shiftable or semi-interuptable shiftable device constraint. The window constraint merely requires that the power flow to a device is zero except within a sliding window of some fixed length. The window constraint is defined as follows:

\begin{align}
  Q_d \in \bigcup_{s \in \{1..n-w\}} \{ x \in \mathbb{R}^n | \ x_i = 0\ \text{when}\ i \notin \{s..(s+w-1)\}\}
\end{align}

where $w \in T$ is the window length, and $s$ is the window start time. Note that if only certain start times are allowed this is enforced with the interval bound. The cumulative amount of flow within the window can be constrained via the cumulative bound. An uninterruptible shiftable device also may or may not have discrete run levels.

\subsection{Cost Functions}\label{sec-cost-functions}
This section defines four specific cost functions that we employ for modelling devices in the case study of section \ref{sec-experiments}. Three of the four cost functions are for load only devices. For these devices we find it more intuitive to think in terms of utility functions and so we use utility functions to define flexibility of these devices, not cost functions directly. The corresponding cost function (also sometimes called ``\textit{dis}-utility'' function) is obtained by merely negating the utility function.

\subsubsection{Interval Load Quadratic Utility (ILQU) and Cumulative Load Quadratic Utility (CLQU)}
The $ILQU$ and $CLQU$ utility functions provide a flexible and intuitive way to express the price elasticity (i.e. demand response) of a load device. The difference between the two is $ILQU$ specifies flexibility between the upper and lower bounds of an interval bound, where as $CLQU$ specifies flexibility between the upper and lower bound of a cumulative bound. In order to define a $ILQU$ or $CLQU$ utility function for a device a corresponding interval bound or cumulative bound respectively must also be defined for the device.

Both functions take two parameters, $P_1$ and $P_0$, where $P_1 > P_0 \ge 0$. $P_0$ specifies the marginal cost at which demand response starts, and $P_1$ specifies the marginal cost at which demand response stops. These always occur at the hard upper/lower bounds respectively. Both functions are defined with the help of the intermediate function $LQU$:

\begin{align}
  ILQU(Q_d) & = \frac{1}{n} \sum_{t=1}^n LQU(Q_{d,t}, Q_{d,t}^{min}, Q_{d,t}^{max}, P_0, P_1)\\
  CLQU(Q_d) & = LQU(\sum_{t=1}^n Q_{d,t}, E_{d}^{min}, E_{d}^{max}, P_0, P_1)\\
  LQU(q; & min, max, P_0, P_1) = (max - min)\left( \right.\nonumber \\
  &\qquad \left. {} \frac{P_0 - P_1}{2}((q - min)/(max - min))^2 \right.\nonumber \\
  &\qquad \left. + P_1 ((q - min)/(min - max))\right)
\end{align}
% \tilde{n}(x) & = (x - x_{min})/(x_{max} - x_{min})

\subsubsection{Temperature Quadratic Utility (TempQU)}
The $TempQU$ function is the inverted quadratic shown in figure \ref{fig-TempQU}, used to model price elasticity w.r.t. temperature variation from a set point of some device responsible for heating or cooling device. In order to define a $TempQU$ utility function for a device a corresponding accumulative bound must be defined on the device. $TempQU$ is a function of the stored energy state of the device $S_{d,t}$ (equation \ref{eq-di}), which is assumed to have units of temperature. The quadratic curve is such that the gradient (marginal cost) is +/- 1 when the temperature drifts -/+ $S_{range}$ from the ideal temperature $S_{opt}$. $TempQU$ is defined:

\begin{align}
  TempQU(S_d, S_{opt}, S_{range}) & = \sum_{t=1}^n (((S_{d,t} - S_{opt})/S_{range})^2 \nonumber \\
  & + (S - S_{opt})/S_{range})
\end{align}

\subsubsection{Generator Quadratic Cost (GQC)}
Finally, a simple separable quadratic function, $GQC$, is used to model the cost small scale generators in the following section, which is merely:

\begin{align}
  GQC(Q_d) & = \sum_{t=1}^n a Q_{d,t}^2 + b Q_{d,t} + c
\end{align}

for some device specific non-negative scalars $a,b,c$, without regard to any particular device constraints.

\begin{figure}[t!]
  \centering
  \caption{Depiction of load device utility functions used in simulation for illustrative purposes. \label{fig-utility-functions}}
  \begin{subfigure}[t]{0.25\textwidth}
    \centering{\includegraphics[width=1.0\textwidth]{./img/idevice2-demo.eps}}
    \caption{CLQU and ILQU example\label{fig-uql}}
  \end{subfigure}%
  ~
  \begin{subfigure}[t]{0.25\textwidth}
    \centering{\includegraphics[width=1.0\textwidth]{./img/tdevice-demo.eps}}
    \caption{TempQU example\label{fig-TempQU}}
  \end{subfigure}
\end{figure}

\section{Relaxation and Refitting}\label{sec-rnr}
If the device modelling involves any levels or window constraints the feasible space is not convex and the central optimisation problem can not be solved exactly with convex optimisation. If we relax any levels and window constraint we can find an approximate solution via convex optimisation. However, this relaxed solution will likely be infeasible, and the relaxed constraints must be reintroduced, a process we've called refitting (also sometimes called ``tightening'').

To relax a non convex constraint there is at least three possible strategies; 1. approximate it with a convex constraint. 2. Replace the hard constraint with a convex penalizing cost function. 3. Just remove the constraint entirely. In this work we opt for a very simple relaxation for the two non-convex constraints; Any levels constraint is relaxed to the continuous range between the lower and upper level and becomes an \textit{ibound} constraint and any window constraint is removed entirely.

\subsection{Refitting}\label{sec-refitting}
There is more than one way the refitting could be performed, with different trade-offs between accuracy, computational complexity, and coupling. What is appropriate depends on how and if the problem is decomposed. In general, we can trade-off individual device profile fit for a better aggregate profile fit amongst some group of devices. The most obvious groupings of devices are \textit{all} devices globally, or those belonging to each bus / sub-network. The latter case is more amenable to a decomposition of the central optimization problem. However, when considering a group of devices at any level, the problem becomes multi objective; how should we trade-off individual device profile fit against aggregate profile fit? The simplest approach is to handle each device independently, ignoring aggregate fit. This has the advantage of being less computationally expensive, but will likely yield a less accurate aggregate fit. We limit ourselves to this approach in this investigation.

To account for all the relaxed discrete constraints, we solve the following quadratic mixed integer problem for each individual device:

\begin{align}
  \argmin_{q \in Y_d} ||q - Q_d^*||^2
\end{align}

where $Q_d^{*}$ is the optimal relaxed profile for device $d$, and $Y_d$ is the finite set of feasible solutions when the non-convex constraints are reintroduced.

\section{Numerical Experiments}\label{sec-experiments}
Section \ref{sec-case-study} presents the details of a case study we used to numerically evaluate the effectiveness of the relaxation approach described above in the context of optimal microgrid scheduling. Section \ref{sec-results} presents results and analysis. Centralized optimisation was used to solve the optimisation objective in equation (\ref{eq-central-objective}). The Python code for the framework used and configuration of the case study are freely available online \cite{Pinkus2019RefittingReportScenario}.

\subsection{Case Study}\label{sec-case-study}

\subsubsection{Microgrid Structure}
The make up of the hypothetical microgrid is based on future projections for a rural microgrid case study previously discussed in \cite{Morsali2018Demand}. There are 8 rural sites connected to an islanded microgrid. The microgrid has a central:

\begin{itemize}
  \item Fossil fuel generator.
  \item Photo voltaic (PV) installation.
  \item Large battery.
\end{itemize}

Each of the 8 sites contains a community of people living and working at and around the site. All sites share the same base set of devices and two site types extend that base device set. The base set of devices is:

\begin{itemize}
  \item An electrical vehicle (EV).
  \item A large sized domestic fridge.
  \item A water pump.
  \item Lighting.
  \item An unscheduled load component representing miscellaneous small appliances such as radios and TVs.
\end{itemize}

Sites are of type \textit{early}, \textit{mid} or \textit{late} type. This determines when lights are required, when EV is available for charging, and when the pump may run (see table \ref{tab-params}).

Two of the site types extend the base type in running specialised equipment. A \textit{farmer} type runs a large machine during the day time. The machine must run for between 4 and 5 hours and is semi-interuptable, being able to run at a low power rate for a maximum of any 2 hours. A \textit{hunter} type has a large freezer that runs 24/7 in addition to base refrigeration requirements. All farmer sites are also early sites, and all hunter site are also late sites. Base sites are a mix. In this scenario there are (2, 2, 4) (farmer, hunter, base) sites.

\subsubsection{Microgrid Device Parameter Details}
Table \ref{tab-params} shows all constraints, costs and parameters for all devices in the simulation. No network capacity constraints were set. Power is in unit of kilowatts. Time is in units of the scheduling interval which is 1 hour. Time is indexed from 0, with 0 corresponding to the time interval 00:00-01:00).

The cost of power from the fossil fuel based generator is modelled with a quadratic. The coefficients are based on those in \cite{Zhang2013Robust} with the capacity scaled down by a factor of 4. No cost function was set on the battery, but a round-trip efficiency factor of 0.94 represents a cost in using the battery. The expected PV energy profile is shown in figure \ref{fig-pv-prof} and was taken from \cite{Morsali2018Demand}. The expected unscheduled load profiles are shown in figure \ref{fig-nschd-prof}. Unscheduled load was pseudo randomly generated such that there are peaks in the morning and evening. The ratio of unscheduled load is relatively low in this scenario at 9.2\% of the base case load.

All pumps, machines and thermal devices (fridges and freezers) have a small number of discrete run levels (table \ref{tab-params}). Machines have a $window$ constraint, as they are semi-interuptable. EVs and lighting can consume energy at any rate between a lower and upper bound. The $CLQU$ and $ILQU$ utility functions are used to govern demand response from EVs and lighting respectively.

For thermal devices, we assume outside temperature is a constant 24 degrees. All thermal devices are constrained to have 3 discrete run levels, \textit{off}, \textit{nominal}, and \textit{high}. Energy consumption in high mode is double nominal. The thermal devices are parametrised such that running at the \textit{nominal} rate continuously results in the optimal set point temperature. An accumulative bound is set to allow drift of +/- 2 degrees from the set point, and the $TempQU$ utility function is used to govern demand response of thermal devices.

\begin{figure}[t!]
  \centering
  \caption{Fixed expected profiles for PV and unscheduled load used in simulation. \label{fig-profiles}}
  \begin{subfigure}[t]{0.25\textwidth}
    \centering{\includegraphics[width=1.0\textwidth]{./img/pv-profile.eps}}
    \caption{Expected PV energy production profile.\label{fig-pv-prof}}
  \end{subfigure}%
  ~
  \begin{subfigure}[t]{0.25\textwidth}
    \centering{\includegraphics[width=1.0\textwidth]{./img/unscheduled-profiles.eps}}
    \caption{Expected unscheduled energy consumption for all 8 sites.\label{fig-nschd-prof}}
  \end{subfigure}
\end{figure}

\subsection{Results}\label{sec-results}
Results are presented in the following two sub sections. Section \ref{sec-results-1} compares the demand response (DR) case to the base case no demand response (NODR). In the NODR case there is no demand response from consumers, but optimal utilisation of battery given the expected PV and fixed load profiles. The difference in the DR case is that demand response of sites is enabled. In the DR case, for devices with relaxed non convex constraints, the resultant schedules will likely be infeasible, so refitting the relaxed constraints as described in section \ref{sec-refitting} is required. Section \ref{sec-results-2} compares the DR case to the DR case after this refitting (DRF).

\subsubsection{NODR vs DR}\label{sec-results-1}
Figure \ref{fig-base-case} shows the base case profile for all loads, battery, PV, and generator. Note the base case load profile is significantly flattened out by the presence of EVs which are set to charge over night. Overall, without demand response EVs account for \%27.3 of total load. Total load by device type is shown in table \ref{tab-load-by-type}.

Figure \ref{fig-convex-dr} shows the optimised profiles when demand response is included (before refitting). The demand response of consumers includes both a shifting and reduction of controllable device consumption. The presence of essentially free energy from the large PV also has a major impact on the aggregate load profile. Pump and machine loads significantly shift demand into the envelop of the PV profile. This can also be seen in the load profiles for site 1 in figure \ref{fig-site1-dr}. Usage of the battery is significantly decreased in the DR case. This is because shifting of most load is essentially free where as using the battery involves inefficiency losses.

Because of the reduction of EV and lighting loads, and to a very small degree fridges and freezers, the aggregate consumption is 6.3\% less than in the NODR case as shown in table \ref{tab-agg-stats}. Table \ref{tab-agg-stats} shows due to the combined demand response effects of shifting and reduction, the generation costs are reduced by 14.0\%, or \$7.41. Accounting for disutility costs, the total costs are reduced to by 8.1\% or \$4.29. The peak load is reduced over 2.9kW and load factor is also improved.

Demand response in the fridge and freezer devices turned out to be small in this scenario. This can be seen in figure \ref{fig-base-vs-dr}. The maximum temperature deviation was less than 0.5 degrees in all cases. The marginal costs were not large enough to push the thermal devices to their hard temperature bounds in this scenario.

\begin{figure}[!h]
    \centering
    \caption{NODR vs DR cases. All unscheduled loads are shown combined into one aggregate unscheduled load in the NODR case.}
    \begin{subfigure}[t]{0.25\textwidth}
	    \includegraphics[width=1.00\textwidth]{scenario2.py-network-latest-base-case-report/animation-mg-0001.eps}
	    \captionof{figure}{\label{fig-base-case}}
    \end{subfigure}%
    ~
    \begin{subfigure}[t]{0.25\textwidth}
	    \includegraphics[width=1.00\textwidth]{scenario2.py-network-latest-report/animation-mg-0001.eps}
	    \captionof{figure}{\label{fig-convex-dr}}
    \end{subfigure}
\end{figure}

\begin{table}[!h]
% Key aggregate statistics for the three simulation cases
\label{tab-agg-stats}
{\begin{tabular*}{20pc}{@{\extracolsep{\fill}}llll@{}}\toprule
& NODR & DR & DRF \\
\midrule
total load (kW) & 176.150 & 164.992 & 165.294 \\
peak load (kW) & 12.887 & 9.957 & 11.860 \\
load factor & 0.570 & 0.690 & 0.581 \\
generation cost (\$) & 53.087 & 45.672 & 46.153 \\
disutility cost (\$) & 0.000 & 3.122 & 3.122 \\
total cost (\$) & 53.087 & 48.794 & 49.275 \\
\bottomrule
\end{tabular*}}{}
\end{table}

\begin{table}[!h]
% Break down of total load by device type for the three simulation cases
\label{tab-load-by-type}
{\begin{tabular*}{20pc}{@{\extracolsep{\fill}}llll@{}}\toprule
\toprule
TYPE & NODR (kWh) & DR (kWh) & DRF (kWh) \\
\midrule
ev & 48.000 & 41.295 & 41.295 \\
freezer & 12.000 & 11.937 & 12.000 \\
fridge & 23.040 & 22.801 & 23.040 \\
light & 9.600 & 5.529 & 5.529 \\
machine & 16.000 & 16.000 & 16.000 \\
unsched & 16.230 & 16.230 & 16.230 \\
wpump & 51.200 & 51.200 & 51.200 \\
\bottomrule
\end{tabular*}}{}
\end{table}


\begin{figure}[!h]
    \caption{NODR vs DR load profiles for selected sites. Note non-convex constraints have not been reintroduced. \label{fig-base-vs-dr}}
    \begin{subfigure}[t]{0.25\textwidth}
	    \includegraphics[width=1.00\textwidth]{scenario2.py-network-latest-report/animation-site1-0000.eps}
	    \captionof{figure}{Site 1 no demand response. \label{fig-site1-nodr}}
    \end{subfigure}%
    ~
    \begin{subfigure}[t]{0.25\textwidth}
	    \includegraphics[width=1.00\textwidth]{scenario2.py-network-latest-report/animation-site1-0001.eps}
	    \captionof{figure}{Site 1 demand response. \label{fig-site1-dr}}
    \end{subfigure}
    ~
    \begin{subfigure}[t]{0.25\textwidth}
	    \includegraphics[width=1.00\textwidth]{scenario2.py-network-latest-report/animation-site5-0000.eps}
	    \captionof{figure}{Site 5 no demand response. \label{fig-site5-nodr}}
    \end{subfigure}%
    ~
    \begin{subfigure}[t]{0.25\textwidth}
	    \includegraphics[width=1.00\textwidth]{scenario2.py-network-latest-report/animation-site5-0001.eps}
	    \captionof{figure}{Site 5 demand response. \label{fig-site5-dr}}
    \end{subfigure}
    ~

    \begin{subfigure}[t]{0.25\textwidth}
	    \includegraphics[width=1.00\textwidth]{scenario2.py-network-latest-report/animation-site7-0000.eps}
	    \captionof{figure}{Site 7 no demand response. \label{fig-site7-nodr}}
    \end{subfigure}%
    ~
    \begin{subfigure}[t]{0.25\textwidth}
	    \includegraphics[width=1.00\textwidth]{scenario2.py-network-latest-report/animation-site7-0001.eps}
	    \captionof{figure}{Site 7 demand response. \label{fig-site7-dr}}
    \end{subfigure}
\end{figure}

\begin{figure}[!h]
  \centering{\includegraphics[width=0.44\textwidth]{./img/temp-mg-site7-freezer.eps}}
  \caption{Expected variation in temperature due to demand response for site 7 freezer. Variation is similar in scale for all other thermal devices.\label{fig-temp-var}}
\end{figure}

\subsubsection{DR vs DRF}\label{sec-results-2}
Figure \ref{fig-agg-fit} shows the overall difference between the relaxed solution and refitted solution. Table \ref{tab-agg-fit} lists aggregate error statistics in total, and for each type of device with relaxed constraints. In this scenario, the fitting error is quite small in aggregate despite 61\% of the demand response load having relaxed constraints reintroduced. The absolute error for machine and pump device types is zero since the cumulative demand constraints are maintained in the relaxed solution. Overall the MAPE (Mean Absolute Percentage Error) is low at 5.7\%. However, MAPE is much higher for the window constraints of machine type devices (37.2\%). This error is also the primary cause of an increase in peak load of 1.9kW in the refitted solution (table \ref{tab-agg-stats}). Still, visually the fit for machine types devices appears fair (figure \ref{fig-mfit-site5-mach}). The semi-interuptable nature of machines helps the refitting more closely match the relaxed profile.

For the fridge and freezer devices, the flexibility parameters we chose resulted in a maximum temperature drift from the set points of less than 0.5 of a degree in all cases (see figure \ref{fig-temp-var}). The corresponding change in consumption was not enough to cause any divergence the nominal consumption rate. Because of the course run level constraints imposed on these devices, flexibility was not ultimately exploitable under the specific microgrid scenario tested. Thus, at least in this scenario, treating these devices as unscheduled loads would have resulted in a marginally better result because there would be no refitting to account for.

It is assumed all balancing is handled by regulating the generator output. Under this assumption, table \ref{tab-agg-stats} shows the overall cost of refitting is relatively small in this scenario at \$0.48. This reduces daily total savings to \%7.2, or \$3.81 per day. The low additional cost of refitting is explainable by the fact that the absolute error between the DR and DRF cases is very low, and the optimal load profile of the generator is very flat in the DR solution, meaning moving a small amount of scheduled generation from one time to another has little additional cost.

\begin{table}[!t]
% DR vs DRF case aggregate error statistics
\label{tab-agg-fit}
{\begin{tabular*}{20pc}{@{\extracolsep{\fill}}llll@{}}\toprule
& Absolute (kW)  & Relative (\%) & MAPE (\%) \\
\midrule
ev & 0.000 & 0.000 & 0.000 \\
freezer & -0.063 & -0.526 & 1.582 \\
fridge & -0.239 & -1.047 & 2.279 \\
light & 0.000 & 0.000 & 0.000 \\
machine & 0.000 & 0.000 & 37.206 \\
unsched & 0.000 & 0.000 & 0.000 \\
wpump & -0.000 & -0.000 & 8.549 \\
total & -0.301 & -0.183 & 5.709 \\
\bottomrule
\end{tabular*}}{}
\end{table}

\begin{figure}
  \centering{\includegraphics[width=0.44\textwidth]{scenario2.py-network-fitting-report/fit-aggregate.eps}}
  \caption{Aggregate profile of DR vs DRF cases.\label{fig-agg-fit}}
\end{figure}

\begin{figure}[!t]
  \caption{DR vs DRF profiles for a selected devices. \label{fig-fits}}
  \begin{subfigure}[t]{0.25\textwidth}
    \includegraphics[width=1.00\textwidth]{scenario2.py-network-fitting-report/fit-mg-site0-wpump.eps}
    \captionof{figure}{Site 0 pump refitting}
  \end{subfigure}%
  ~
  \begin{subfigure}[t]{0.25\textwidth}
    \includegraphics[width=1.00\textwidth]{scenario2.py-network-fitting-report/fit-mg-site1-wpump.eps}
    \captionof{figure}{Site 1 pump refitting}
  \end{subfigure}
  ~
  \begin{subfigure}[t]{0.25\textwidth}
    \includegraphics[width=1.00\textwidth]{scenario2.py-network-fitting-report/fit-mg-site5-machine.eps}
    \captionof{figure}{Site 5 machine refitting \label{fig-mfit-site5-mach}}
  \end{subfigure}%
  ~
  \begin{subfigure}[t]{0.25\textwidth}
    \includegraphics[width=1.00\textwidth]{scenario2.py-network-fitting-report/fit-mg-site7-freezer.eps}
    \captionof{figure}{Site 7 freezer refitting}
  \end{subfigure}
  ~
\end{figure}

\section{Conclusion}\label{sec-conclusion}
In this report we developed a set of device modelling constraints, condensing and generalising work from previous publications. We included two commonly encountered non-convex constraints in our modelling and suggested given the scope of the problem being considered (day-ahead scheduling), rather than abandoning the benefits of convex modelling for the sake of absolute precision, a relaxation and refitting approach could be used to deal with these constraints. To provide some objective support for this argument we constructed a model for a rural microgrid case study of interest to us and simulated the approach. The results show the estimated additional cost of the relaxation and refitting approach to dealing with non-convex constraints was much less than the overall potential savings from demand response, and in the order of that which would be expected from forecasting errors in a typical microgrid scenario.

\subsection{Future Work}
The relaxation and refitting approach we used in this work has a number of limitations. For the relaxation of the window constraints we simply removed it, where as replacing it with a convex penalty function is a possible alternative. Secondly, in section \ref{sec-refitting} we discussed the possibility of doing the refitting of constraints to device profiles considering many devices at once at the level of the sub-network / tenant site. In future work we are interested in looking at this. Thirdly, uncoordinated refitting can lead to high peaks in aggregate load profile as was shown in our numerical experiments. A simple secondary market, similar to that often used to deal with balancing errors is potentially better mechanism for dealing with errors resulting from the relaxation. Unlike forecasting errors the refitting errors are known in advance of realtime and can therefore potentially be dealt with more efficiently in such a secondary market.

%\section{Acknowledgements}\label{acknowledgements}
% TODO CGREI, Australian Research Grant (need to find out grant number)

\bibliography{refs}

\clearpage

\section{Appendices}\label{appendices}

\subsection{Simulation Parameters}

Table \ref{tab-params} shows the parameters settings for the microgrid simulation. Power is in unit of kilowatts. Time is in units of the scheduling interval which is 1 hour. Time begins at 0, and 0 corresponds to the interval 00:00-01:00. We have used various notations and short hands in the table:

\begin{itemize}
  \item A ``Nil'' means a constraint is omitted for the given device type.
  \item A contiguous time span maybe specified by a tuple $(i,j)$, which means the time from the $i$-th and $j$-th time slot inclusive.
  \item For $ibound$, rather than explicitly specifying two vectors of length $n$, we optionally use a more succinct notation if possible: A lower and upper scalar, and optionally a subset of $T$ to which that bound applies. For all other times the bounds are taken to be $(0,0)$. If no times are specified the bound applies to all times.
  \item For an $abound$ modelling a thermal device, energies are in degrees Celsius of some (assumed) fixed mass. $E_0$ is relative to the constant external temperature and needs to be adjusted relative to this. To aid readability we indicate this by wrapping the parameters in $t(\cdot, external\_temp)$ which adjusts temperatures relative to $external\_temp$.
  \item Utility functions listed generally are parametrised by the constraints of the device they apply to, but for brevity we don't show this.
\end{itemize}

\begin{table}[!h]
% Microgrid simulation parameters
\label{tab-params}
{\begin{tabular*}{\textwidth}{@{\extracolsep{\fill}}lllllll}\toprule
device $(type\-count)$         & ibound                   & cbound      & abound $(E_0,E_{min},E_{max},E_{end},k,f,d)$ & levels & window $(i,j,k)$   & cost \\
\midrule
Unscheduled (8)      & see figure \ref{fig-nschd-prof} & Nil         & Nil                                  & Nil     & Nil & Nil \\
Water Pump Early (3) & (0,1.2), {8..19}                & Nil         & Nil                                  & (0,0.4,0.8,1.2) & Nil & Nil \\
Water Pump Mid (2)   & (0,1.2), {8..19}                & Nil         & Nil                                  & (0,0.4,0.8,1.2) & Nil & Nil \\
Water Pump Late (3)  & (0,1.2), {12..19}               & Nil         & Nil                                  & (0,0.4,0.8,1.2) & Nil & Nil \\
EV Early (3)         & (0,2), {0..4,18..23}            & (4.5, 6)    & Nil                                  & Nil              & Nil & CLQU(0.04,1) \\
EV Mid (2)           & (0,2), {0..6,20..23}            & (4.5, 6)    & Nil                                  & Nil              & Nil & CLQU(0.04,1) \\
EV Late (3)          & (0,2), {0..8,22..23}            & (4.5, 6)    & Nil                                  & Nil              & Nil & CLQU(0.04,1) \\
Light Early (3)      & (0.075,0.2), {18..23}           & Nil         & Nil                                  & Nil     & Nil & ILQU(0.04,1) \\
Light Mid (2)        & (0.075,0.2), {19..23}           & Nil         & Nil                                  & Nil     & Nil & ILQU(0.04,1) \\
Light Late (3)       & (0.1,0.2), {0,20..23}           & Nil         & Nil                                  & Nil     & Nil & ILQU(0.04,1) \\
Fridge (8)           & (0,0.24)                        & (2.88,3)    & t((3,1,5,Nil,-13.7,0.95,0.926), 24)       & (0,120,240)      & Nil & TempQU(3,4) \\
Freezer (2)          & (0,0.5)                         & (6,6.5)     & t((-18,-20,-16,Nil,-12.6,0.95,0.929), 24) & (0,250,500)      & Nil & TempQU(-18,4) \\
Machine (2)          & (0,2), {7..19}                  & (8,8)       & Nil                                  & (0,1,2) & (4,5,0.01) & Nil \\
FG (1)               & (-11.25,-2)                     & Nil         & Nil                                  & Nil     & Nil & GQC(0.028, 0.30, 0) \\
PV (1)               & see figure \ref{fig-pv-prof}    & Nil         & Nil                                  & Nil     & Nil & Nil \\
Battery (1)          & (-9.5,9.5)                      & Nil         & (16,0,32,16,1,0.97,1)                & Nil & Nil & Nil \\
\bottomrule
\end{tabular*}}{}
\end{table}

\end{document}
